<?
/**
* Plugin zum Verwalten eines Gruppenkalenders
*
* @author               Jan Kulmann <jankul@zmml.uni-bremen.de>
*
*/

// +---------------------------------------------------------------------------+
// This file is NOT part of Stud.IP
// Copyright (C) 2008 Jan Kulmann <jankul@zmml.uni-bremen.de>
// ATTENTION: Please send ALL bug reports and security leaks directly to the author.
//            Thx!
// +---------------------------------------------------------------------------+
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or any later version.
// +---------------------------------------------------------------------------+
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// +---------------------------------------------------------------------------+


page_open(array('sess' => 'Seminar_Session', 'auth' => 'Seminar_Default_Auth', 'perm' => 'Seminar_Perm', 'user' => 'Seminar_User'));

$GLOBALS['perm']->check('autor');

require_once("classes/GkConfig.class.php");
require_once("classes/DBM.class.php");
require_once("lib/functions.php");
require_once('lib/classes/Avatar.class.php');
require_once('vendor/flexi/template_factory.php');

$template_path = dirname(__FILE__) . '/templates/flexi';
$factory = new Flexi_TemplateFactory($template_path);

if (!array_key_exists('ajax_cmd', $_REQUEST)) die;

switch($_REQUEST['ajax_cmd']) {
	case 'updateDate':
		$range_id = escapeshellcmd(basename(trim($_REQUEST['range_id'])));
		$termin_id = escapeshellcmd(basename(trim($_REQUEST['termin_id'])));
		$stunde = escapeshellcmd(basename(trim($_REQUEST['stunde'])));
		$minute = escapeshellcmd(basename(trim($_REQUEST['minute'])));
		$tag_txt = escapeshellcmd(basename(trim($_REQUEST['tag_txt'])));
		if ($GLOBALS['perm']->have_studip_perm('autor', $range_id)) {
			list($tag, $monat, $jahr) = explode('.',$tag_txt);
			if ($newtime = mktime($stunde, $minute, 0, $monat, $tag, $jahr)) {
				$db = new DB_Seminar();
				$db->queryf("SELECT * FROM gk_termine WHERE range_id='%s' AND termin_id='%s'", $range_id, $termin_id);
				if ($db->next_record()) {
					$delta_t = $db->f("end_time") - $db->f("date");
					$end_time = $newtime + $delta_t;
					$db->queryf("UPDATE gk_termine SET date=%d, end_time=%d, chdate=UNIX_TIMESTAMP(), ch_user_id='%s' WHERE range_id='%s' AND termin_id='%s'", $newtime, $end_time, $GLOBALS['auth']->auth['uid'], $range_id, $termin_id);
				}
			}
		}
		//echo "range_id = $range_id, termin_id = $termin_id, stunde = $stunde, minute = $minute, tag_txt = $tag_txt";
		break;
	case 'getDetails':
		$von = escapeshellcmd(basename(trim($_REQUEST['von'])));
		$bis = escapeshellcmd(basename(trim($_REQUEST['bis'])));
		$termin_id = escapeshellcmd(basename(trim($_REQUEST['termin_id'])));
		$range_id = escapeshellcmd(basename(trim($_REQUEST['range_id'])));
		if ($von != "" && $bis != "") {
			$config = new GkConfig($GLOBALS['auth']->auth['uid'], $range_id);
			$dbm = new DBM(&$config);
			$termin_texte = "";
			if ($termin_id)
				$t_dates = $dbm->getSingleDate($termin_id, $range_id);
			else
				$t_dates = $dbm->getDatesInRange($von, $bis, $range_id, FALSE, "date");
			if (count($t_dates) > 0) {
				$anz = count($t_dates);
				foreach ($t_dates as $t) {
					$anz--;
					$serien_info = "";
					$t_serie = $dbm->getSerienInfo($t->getSerieId());
					if (is_array($t_serie) && $t_serie['anz'] != '0') {
						$serien_info = "Einzeltermin einer Serie vom ".date('d.m.Y',$t_serie['start'])." bis zum ".date('d.m.Y',$t_serie['ende'])." (".$t_serie['anz']." Termine)";
					}
					$t_title = htmlReady($t->getTitle());
	                                $t_ort = htmlReady($t->getOrt());
        	                        $t_content = formatReady($t->getContent());
					$change = ($t->getChUserId() ? "(ge&auml;ndert von <A HREF=\"about.php?username=".get_username($t->getChUserId())."\">".get_fullname($t->getChUserId())."</A>, ".date('d.m.Y H:i', $t->getChDate()).")" : "");
					if ($t->getSrc() == "tv_cal") {
						$buchungen = DBM::getTerminBuchungen($t->getTerminId());
						$template = $factory->open('details_terminbuchung');
						$template->set_attribute('anz_buchungen', $buchungen['anz_buchungen']);
						$template->set_attribute('bookings', $buchungen['bookings']);
						$t_content .= $template->render();
					}
					if (date('d.m.Y',$t->getVon()) != date('d.m.Y',$t->getBis())) {
						$anzeige_zeit = date("d.m.Y H:i",$t->getVon())." - ".date("d.m.Y H:i",$t->getBis());
						if ($t->getFulltime() == 1) $anzeige_zeit .= "<BR><I>Ganzt&auml;giger Termin</I>";
					} else {
		                                $anzeige_zeit = date("d.m.Y H:i",$t->getVon())." - ".date("H:i",$t->getBis());
					}
					$template = $factory->open('details');
					$template->set_attribute('title', $t_title);
					$template->set_attribute('anzeige_zeit', $anzeige_zeit);
					$template->set_attribute('ort', $t_ort);
					$template->set_attribute('avatar_img', Avatar::getAvatar($t->getUserId())->getImageTag(Avatar::SMALL));
					$template->set_attribute('username', get_username($t->getUserId()));
					$template->set_attribute('fullname', get_fullname($t->getUserId()));
					$template->set_attribute('serien_info', $serien_info);
					$template->set_attribute('content', $t_content);
					$template->set_attribute('change', $change);
					$template->set_attribute('anz', $anz);

					$termin_texte .= $template->render();
				}
				echo $termin_texte;
			}
		}
		break;
	default: ;
}
?>
