<?php
/**
* Plugin zum Verwalten eines Gruppenkalenders
*
* @author               Jan Kulmann <jankul@zmml.uni-bremen.de>
*
*/

// +---------------------------------------------------------------------------+
// This file is NOT part of Stud.IP
// Copyright (C) 2008 Jan Kulmann <jankul@zmml.uni-bremen.de>
// ATTENTION: Please send ALL bug reports and security leaks directly to the author.
//            Thx!
// +---------------------------------------------------------------------------+
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or any later version.
// +---------------------------------------------------------------------------+
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// +---------------------------------------------------------------------------+

require_once('vendor/flexi/template_factory.php');

class DateController {

	var $dbm;
	var $config;
	var $template_path;
        var $factory;
	var $plugin;
	var $range_id;

	function DateController($dbm, $config, $range_id, $plugin=null) { 
		$this->dbm = &$dbm;
		$this->config = &$config;
		$this->range_id = $range_id;
		$this->plugin = &$plugin;
		$this->template_path = dirname(__FILE__) . '/../templates/flexi/msg';
                $this->factory = new Flexi_TemplateFactory($this->template_path);
	}

	function lastMonday($t) {
                return strtotime("last Monday", $t);
        }

        function nextSunday($t) {
                return strtotime("next Sunday", $t);
        }

        function firstDayOfMonth($t) {
                return strtotime(date("01.m.Y", $t));
        }

        function lastDayOfMonth($t) {
                return strtotime(date("d.m.Y", strtotime("-1 day" ,$this->firstDayOfMonth(strtotime("+1 month",$t)))));
        }

	function weekDaysComputed($this_day, $this_sunday, $start_stunde, $min_hoehe, $tag_weite, $zeit_weite, $wotag_hoehe, $ignore_fulltime=TRUE) {
		$ret = array();

		while ($this_day <= $this_sunday) {
                        //array_push($weekdays, date("d.m.Y",$this_day));
                        $von = strtotime(date("d.m.Y ".$start_stunde.":0:0",$this_day));
                        $bis = strtotime("+1 day",strtotime(date("d.m.Y 00:00:00",$this_day)));
                        //$t_dates = $this->dbm->getDatesInRange($von, $bis, $GLOBALS['SessSemName'][1], $ignore_fulltime);
                        $t_dates = $this->dbm->getDatesInRange($von, $bis, $this->range_id, $ignore_fulltime);
                        $overlapping_dates = array();
                        // Termine in dem Zeitraum
                        if (count($t_dates) > 0) {
                                foreach ($t_dates as $t) {
                                        $wtag = date("w",$this_day);
                                        $wtag = ($wtag == 0 ? 7 : $wtag);
                                        $x1 = ($wtag -1) * $tag_weite + $zeit_weite;
                                        $overlapp = FALSE;
                                        $tmp_date = 0;
                                        $tmp_end_time = 0;

                                        // handelt es sich um einen Termin, der bereits vor diesem Tag begonnen hat, dann muss er zum Anfang dieses Tages dargestellt werden
                                        if (mktime(0,0,0,date('m',$this_day),date('d',$this_day),date('Y',$this_day)) > $t->getVon()) {
                                                $tmp_date = mktime($start_stunde,0,0,date('m',$this_day),date('d',$this_day));
                                        } else $tmp_date = $t->getVon();
                                        // handelt es sich um einen Termin, der Mitternacht dieses Tages ueberschreitet, dann muss er bis zum Ende des Tages dargestellt werden
                                        if (mktime(0,0,0,date('m',$this_day),date('d',$this_day) + 1 ,date('Y',$this_day)) < $t->getBis()) {
                                                $tmp_end_time = mktime(0,0,0,date('m',$this_day),date('d',$this_day) + 1 ,date('Y',$this_day));
                                        } else $tmp_end_time = $t->getBis();

                                        //$anz = $this->dbm->has_overlapping_dates($t->getTerminId(), $tmp_date, $tmp_end_time, $GLOBALS['SessSemName'][1]);
                                        $anz = $this->dbm->has_overlapping_dates($t->getTerminId(), $tmp_date, $tmp_end_time, $this->range_id);

                                        if (count($anz) > 1) {
                                                $pos = 1;
                                                foreach ($anz as $a) {
                                                        if (!array_key_exists($a, $overlapping_dates))
                                                                $overlapping_dates[$a] = array("position"=>$pos, "max_count"=>count($anz));
                                                        $pos++;
                                                }
                                                $tmp_tag_weite = floor($tag_weite / $overlapping_dates[$t->getTerminId()]['max_count']);
                                                $x1 += $tmp_tag_weite * ($overlapping_dates[$t->getTerminId()]['position'] - 1);
                                                $overlapp = TRUE;
                                        } else
                                                $tmp_tag_weite = $tag_weite;

                                        $x2 = $x1 + $tmp_tag_weite + $zeit_weite;
                                        $y1 = date("G",$t->getVon()) * 60 + ltrim(date("i",$t->getVon()), "0") - ($start_stunde * 60) + $wotag_hoehe; // Zeit von
                                        $y2 = date("G",$t->getBis()) * 60 + ltrim(date("i",$t->getBis()),"0") - ($start_stunde * 60) + $wotag_hoehe; // Zeit bis

                                        $anzeige_zeit = $anzeige_zeit = date("H:i",$t->getVon())." - ".date("H:i",$t->getBis());

                                        // handelt es sich um einen Termin, der bereits vor diesem Tag begonnen hat, dann muss er zum Anfang dieses Tages dargestellt werden
                                        //if (mktime(0,0,0,date('m',$this_day),date('d',$this_day),date('Y',$this_day)) >= $t->getVon()) {
                                        if (mktime($start_stunde,0,0,date('m',$this_day),date('d',$this_day),date('Y',$this_day)) >= $t->getVon()) {
                                                //$t['date_type'] = 2;
                                                $anzeige_zeit = date("d.m.Y H:i",$t->getVon())." - ".date("d.m.Y H:i",$t->getBis());
                                                $y1 = $wotag_hoehe;
                                        }
                                        // handelt es sich um einen Termin, der Mitternacht dieses Tages ueberschreitet, dann muss er bis zum Ende des Tages dargestellt werden
                                        if (mktime(0,0,0,date('m',$this_day),date('d',$this_day) + 1 ,date('Y',$this_day)) <= $t->getBis()) {
                                                //$t['date_type'] = 2;
                                                $anzeige_zeit = date("d.m.Y H:i",$t->getVon())." - ".date("d.m.Y H:i",$t->getBis());
                                                $y2 = 60 * (24 - $start_stunde) + $wotag_hoehe;
                                        }

                                        // wenn aus irgendeinem Grund die Zeit ueber Mitternacht hinausgehen sollte...
                                        if ($y2 < $y1) $y2 = 60 * (24 - $start_stunde) + $wotag_hoehe;
                                        $delta_y = ($y2 - $y1);

                                        // darf der User den Termin ueberhaupt bearbeiten?
                                        //if (!($this->dbm->hasEditRights($GLOBALS['SessSemName'][1], $GLOBALS['auth']->auth['uid'], $t))) {
                                        if (!($this->dbm->hasEditRights($this->range_id, $GLOBALS['auth']->auth['uid'], $t))) {
                                                // anscheinend nicht...
                                                $t->setDateType(0);
                                        }
					// for display purposes
                                        //$delta_y = ($delta_y < $min_hoehe ? $min_hoehe : $delta_y);
                                        //$delta_y -= 2;
                                        //$tmp_tag_weite -=5;

                                        $t->setX($x1);
                                        $t->setY($y1);
                                        $t->setHoehe($delta_y);
                                        $t->setWeite($tmp_tag_weite);
					$t->setOverlapp($overlapp);

					array_push($ret, $t);

                                }
                        }
                        $this_day = strtotime("+1 day", $this_day);
                } // while

		return $ret;

	}

	function daysComputed($von, $bis, $start_stunde, $min_hoehe, $tag_weite, $zeit_weite, $start_offset, $ignore_fulltime=TRUE) {
		$ret = array();

		//$t_dates = $this->dbm->getDatesInRange($von, $bis, $GLOBALS['SessSemName'][1], $ignore_fulltime);
		$t_dates = $this->dbm->getDatesInRange($von, $bis, $this->range_id, $ignore_fulltime);
		// Termine in dem Zeitraum
		if (count($t_dates) > 0) {
                        $overlapping_dates = array();
                        foreach ($t_dates as $t) {
                                $x1 = $zeit_weite;
                                $overlapp = FALSE;
                                $tmp_date = 0;
                                $tmp_end_time = 0;

                                // handelt es sich um einen Termin, der bereits vor diesem Tag begonnen hat, dann muss er zum Anfang dieses Tages dargestellt werden
                                if (mktime(0,0,0,date('m',$von),date('d',$von),date('Y',$von)) > $t->getVon()) {
                                        $tmp_date = mktime($start_stunde,0,0,date('m',$von),date('d',$von));
                                } else $tmp_date = $t->getVon();
                                // handelt es sich um einen Termin, der Mitternacht dieses Tages ueberschreitet, dann muss er bis zum Ende des Tages dargestellt werden
                                if (mktime(0,0,0,date('m',$von),date('d',$von) + 1 ,date('Y',$von)) < $t->getBis()) {
                                        $tmp_end_time = mktime(0,0,0,date('m',$von),date('d',$von) + 1 ,date('Y',$von));
                                } else $tmp_end_time = $t->getBis();

                                //$anz = $this->dbm->has_overlapping_dates($t->getTerminId(), $tmp_date, $tmp_end_time, $GLOBALS['SessSemName'][1]);
                                $anz = $this->dbm->has_overlapping_dates($t->getTerminId(), $tmp_date, $tmp_end_time, $this->range_id);

                                if (count($anz) > 1) {
                                        $pos = 1;
                                        foreach ($anz as $a) {
                                                if (!array_key_exists($a, $overlapping_dates))
                                                        $overlapping_dates[$a] = array("position"=>$pos, "max_count"=>count($anz));
                                                $pos++;
                                        }
                                        $tmp_tag_weite = floor(($tag_weite - $zeit_weite) / $overlapping_dates[$t->getTerminId()]['max_count']);
                                        $x1 += ($tmp_tag_weite < $min_weite ? ($tmp_tag_weite - $zeit_weite) : $tmp_tag_weite) * ($overlapping_dates[$t->getTerminId()]['position'] - 1);
                                        $tmp_tag_weite = ($tmp_tag_weite < $min_weite ? ($min_weite - $zeit_weite) : $tmp_tag_weite);

                                        $overlapp = TRUE;
                                } else
                                        $tmp_tag_weite = $tag_weite - $zeit_weite;

                                $y1 = date("G",$t->getVon()) * 60 + ltrim(date("i",$t->getVon()), "0") - ($start_stunde * 60) + $start_offset; // Zeit von
                                $y2 = date("G",$t->getBis()) * 60 + ltrim(date("i",$t->getBis()),"0") - ($start_stunde * 60) + $start_offset; // Zeit bis

                                // handelt es sich um einen Termin, der bereits vor diesem Tag begonnen hat, dann muss er zum Anfang dieses Tages dargestellt werden
                                //if (mktime(0,0,0,date('m',$von),date('d',$von),date('Y',$von)) >= $t->getVon()) {
                                if (mktime($start_stunde,0,0,date('m',$von),date('d',$von),date('Y',$von)) >= $t->getVon()) {
                                        //$t['date_type'] = 2;
                                        $y1 = $start_offset;
                                }
                                // handelt es sich um einen Termin, der Mitternacht dieses Tages ueberschreitet, dann muss er bis zum Ende des Tages dargestellt werden
                                if (mktime(0,0,0,date('m',$von),date('d',$von) + 1 ,date('Y',$von)) <= $t->getBis()) {
                                        //$t['date_type'] = 2;
                                        $y2 = 60 * (24 - $start_stunde) + $start_offset;
                                }

                                // wenn aus irgendeinem Grund die Zeit ueber Mitternacht hinausgehen sollte...
                                if ($y2 < $y1) $y2 = 60 * (24 - $start_stunde) + $start_offset;
                                $delta_y = ($y2 - $y1);

                                // darf der User den Termin ueberhaupt bearbeiten?
                                //if (!($this->dbm->hasEditRights($GLOBALS['SessSemName'][1], $GLOBALS['auth']->auth['uid'], $t))) {
                                if (!($this->dbm->hasEditRights($this->range_id, $GLOBALS['auth']->auth['uid'], $t))) {
                                        // anscheinend nicht...
                                        $t->setDateType(0);
                                }

                                $t->setX($x1);
                                $t->setY($y1);
                                $t->setHoehe($delta_y);
                                $t->setWeite($tmp_tag_weite);
				$t->setOverlapp($overlapp);

				array_push($ret, $t);

                        }
                }


		return $ret;
	}

	function getMessageText($id, $t_type, $mode) {
		$template = $this->factory->open($t_type.'_date_'.$mode);

		if ($t_type == "single") {
			$t = new DateObject();
			$t->load($id);
			$ical_url = $GLOBALS['ABSOLUTE_URI_STUDIP'].$this->plugin->getPluginpath()."/ical.php?cmd=getSingleDate&rid=".$t->getRangeId()."&tid=".$t->getTerminId();
			$sem = get_object_name($t->getRangeId(), 'sem');
	                $template->set_attribute('titel',$t->getTitle());
	                $template->set_attribute('tag', date('d.m.Y',$t->getVon()));
	                $template->set_attribute('zeit_von', date('H:i',$t->getVon()));
	                $template->set_attribute('zeit_bis', date('H:i',$t->getBis()));
	                $template->set_attribute('person', get_fullname($GLOBALS['auth']->auth['uid']));
	                $template->set_attribute('veranstaltung', $sem['name']);
	                $template->set_attribute('ical_url', $ical_url);

		} else if ($t_type == "serie") {
			$serie = $this->dbm->getFirstDateOfSerie($id);
			$serien_info = $this->dbm->getSerienInfo($id);
			$t = new DateObject();
			$t->load($serie['termin_id']);
			$ical_url = $GLOBALS['ABSOLUTE_URI_STUDIP'].$this->plugin->getPluginpath()."/ical.php?cmd=getSerie&rid=".$t->getRangeId()."&tid=".$t->getTerminId();
			$sem = get_object_name($t->getRangeId(), 'sem');
	                $template->set_attribute('titel', $t->getTitle());
	                $template->set_attribute('anz', $serien_info['anz']);
	                $template->set_attribute('tag_von', date('d.m.Y',$serien_info['start']));
	                $template->set_attribute('tag_bis', date('d.m.Y',$serien_info['ende']));
	                $template->set_attribute('zeit_von', date('H:i',$serien_info['start']));
	                $template->set_attribute('zeit_bis', date('H:i',$serien_info['ende']));
	                $template->set_attribute('person', get_fullname($GLOBALS['auth']->auth['uid']));
	                $template->set_attribute('veranstaltung', $sem['name']);
	                $template->set_attribute('ical_url', $ical_url);
		}

                $text = $template->render();
		return $text;

	}

	function notifyUsers($id, $t_type, $mode) {
		$msg_mode = ($mode == "edit" ? "on_update" : "on_create");
		$termin_id = "";
		if ($t_type == "serie") { 
			$serie = $this->dbm->getFirstDateOfSerie($id);
			$termin_id = $serie['termin_id'];
		} else {
			$termin_id = $id;
		}
		$users = $this->dbm->getUserForMessaging($termin_id, $msg_mode);
		$message_text = $this->getMessageText($id, $t_type, $mode);
		$title = ($t_type == "serie" ? "Terminserie" : "Termin")." ".($mode == "edit" ? "verndert" : "angelegt");
		$m = new messaging;
		foreach ($users as $u)
			$m->insert_message($message_text, $u['username'], "____%system%____", FALSE, FALSE, 1, FALSE, $title);
	}

}
?>
