<?php

/**
* Plugin zum Verwalten eines Gruppenkalenders
*
* @author               Jan Kulmann <jankul@zmml.uni-bremen.de>
*
*/

// +---------------------------------------------------------------------------+
// This file is NOT part of Stud.IP
// Copyright (C) 2008 Jan Kulmann <jankul@zmml.uni-bremen.de>
// ATTENTION: Please send ALL bug reports and security leaks directly to the author.
//            Thx!
// +---------------------------------------------------------------------------+
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or any later version.
// +---------------------------------------------------------------------------+
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// +---------------------------------------------------------------------------+


class GkConfig {

	var $neu = TRUE;
	var $user_id = null;
	var $range_id = null;
	var $valid_fields = array('start_time','include_sem_dates','only_own_dates',
				  'quick_create_date','tag_overlapping_dates','include_tv_dates',
				  'include_calendar_dates','start_view','use_pdf_colors','receive_msg',
				  'sem_date_color','tv_date_color','cal_date_color');
	var $fields = array('start_time'=>6, 'include_sem_dates'=>1, 'only_own_dates'=>0, 'quick_create_date'=>0, 
			    'tag_overlapping_dates'=>1, 'include_sem_dates'=>1, 'include_sem_dates'=>1, 'start_view'=>'day',
			    'use_pdf_colors'=>1,'receive_msg'=>'never','sem_date_color'=>'grau','tv_date_color'=>'grau','cal_date_color'=>'grau');
	var $terminvergabe_enabled;

	function GkConfig($user_id, $range_id) {
		$this->terminvergabe_enabled = AbstractPluginIntegratorEnginePersistence::isPluginRegistered("HomepageterminvergabePlugin");
		$this->user_id = $user_id;
		$this->range_id = $range_id;
		$this->load();
	}

	function load() {
		$db = new DB_Seminar();
		$db->queryf("SELECT * FROM gk_config WHERE user_id='%s' AND range_id='%s'",$this->user_id, $this->range_id);
		if ($db->next_record()) {
			$this->neu = FALSE;
			foreach ($this->valid_fields as $v)
				$this->fields[$v] = $db->f($v);
		}
	}

	function save() {
		$db = new DB_Seminar();
		if ($this->neu) {
			$db->queryf("INSERT INTO gk_config (user_id, range_id, start_time, include_sem_dates, only_own_dates, quick_create_date, tag_overlapping_dates, include_tv_dates, include_calendar_dates, start_view, use_pdf_colors, receive_msg, sem_date_color, tv_date_color, cal_date_color) VALUES ('%s','%s',%d, %d, %d, %d, %d, %d, %d, '%s', %d, '%s', '%s', '%s', '%s')",$this->user_id, $this->range_id, $this->fields['start_time'], $this->fields['include_sem_dates'], $this->fields['only_own_dates'], $this->fields['quick_create_date'], $this->fields['tag_overlapping_dates'], $this->fields['include_tv_dates'], $this->fields['include_calendar_dates'], $this->fields['start_view'], $this->fields['use_pdf_colors'], $this->fields['receive_msg'], $this->fields['sem_date_color'], $this->fields['tv_date_color'], $this->fields['cal_date_color']);
			$this->neu = FALSE;
		} else {
			$db->queryf("UPDATE gk_config SET start_time='%s', include_sem_dates=%d, only_own_dates=%d, quick_create_date=%d, tag_overlapping_dates=%d, include_tv_dates=%d, include_calendar_dates=%d, start_view='%s', use_pdf_colors=%d, receive_msg='%s', sem_date_color='%s', tv_date_color='%s', cal_date_color='%s' WHERE user_id='%s' AND range_id='%s'",$this->fields['start_time'], $this->fields['include_sem_dates'], $this->fields['only_own_dates'], $this->fields['quick_create_date'], $this->fields['tag_overlapping_dates'], $this->fields['include_tv_dates'], $this->fields['include_calendar_dates'], $this->fields['start_view'], $this->fields['use_pdf_colors'], $this->fields['receive_msg'], $this->fields['sem_date_color'], $this->fields['tv_date_color'], $this->fields['cal_date_color'], $this->user_id, $this->range_id);
		}
	}

	function get($item) {
		return $this->fields[$item];
	}

	function set($item, $value) {
		if (in_array($item, $this->valid_fields))
			$this->fields[$item] = $value;
	}

	function getArray() {
		return $this->fields;
	}

	function isTerminvergabeEnabled() {
		return $this->terminvergabe_enabled;
	}
}

?>
