<?php
/**
* Plugin zum Verwalten eines Gruppenkalenders
*
* @author               Jan Kulmann <jankul@zmml.uni-bremen.de>
*
*/

// +---------------------------------------------------------------------------+
// This file is NOT part of Stud.IP
// Copyright (C) 2008 Jan Kulmann <jankul@zmml.uni-bremen.de>
// ATTENTION: Please send ALL bug reports and security leaks directly to the author.
//            Thx!
// +---------------------------------------------------------------------------+
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or any later version.
// +---------------------------------------------------------------------------+
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// +---------------------------------------------------------------------------+


class Import {

	function Import() {}

	function fc_csv_import($data) {
                $ret = array();

                $sig = array
                (
                    0 => "Subject",
                    1 => "Start Date",
                    2 => "Start Time",
                    3 => "End Date",
                    4 => "End Time",
                    5 => "All day event",
                    6 => "Reminder on/off",
                    7 => "Reminder Date",
                    8 => "Reminder Time",
                    9 => "Meeting Organizer",
                    10 => "Required Attendees",
                    11 => "Optional Attendees",
                    12 => "Meeting Resources",
                    13 => "Billing Information",
                    14 => "Categories",
                    15 => "Description",
                    16 => "Location",
                    17 => "Mileage",
                    18 => "Priority",
                    19 => "Private",
                    20 => "Sensitivity",
                    21 => "Show time as\""
                );


                /*

        [0] => Array
        (
            [0] => Subject
            [1] => Start Date
            [2] => Start Time
            [3] => End Date
            [4] => End Time
            [5] => All day event
            [6] => Reminder on/off
            [7] => Reminder Date
            [8] => Reminder Time
            [9] => Meeting Organizer
            [10] => Required Attendees
            [11] => Optional Attendees
            [12] => Meeting Resources
            [13] => Billing Information
            [14] => Categories
            [15] => Description
            [16] => Location
            [17] => Mileage
            [18] => Priority
            [19] => Private
            [20] => Sensitivity
            [21] => Show time as"
        )
                */

                foreach ($this->parse($data) as $k=>$line) {
                        if ($k == 0) {
                                if (count(array_diff_assoc($sig, $line))) {
                                        return "errorFalsches Dateiformat!";
                                }
                                continue;
                        }
			$start_date  = str_replace("\"","",trim(utf8_decode($line[1])));
                        $start_time  = str_replace("\"","",trim(utf8_decode($line[2])));
                        $end_date    = str_replace("\"","",trim(utf8_decode($line[3])));
                        $end_time    = str_replace("\"","",trim(utf8_decode($line[4])));
                        $subject     = str_replace("\"","",trim(utf8_decode($line[0])));
                        $description = str_replace("\"","",trim(utf8_decode($line[15])));
                        $location    = str_replace("\"","",trim(utf8_decode($line[16])));

                        if ($subject!='' && $start_date!='' && $start_time!='' && $end_date!='' && $end_time!='') {
                                $start = $start_date.' '.$start_time;
                                $zone = substr($start, -2);
                                $start = substr($start, 0, -3);
                                $start_t = strtotime($start);
                                if ($zone == "PM") {
                                        if (date("H",$start_t) != 12)
                                                $start_t = strtotime("+12 hours",$start_t);
                                } else if ($zone == "AM") {
                                        if (date("H",$start_t) == 12)
                                                $start_t = strtotime("-12 hours",$start_t);
                                }

                                $end = $end_date.' '.$end_time;
                                $zone = substr($end, -2);
                                $end = substr($end, 0, -3);
                                $end_t = strtotime($end);
                                if ($zone == "PM") {
                                        if (date("H",$end_t) != 12)
                                                $end_t = strtotime("+12 hours",$end_t);
                                } else if ($zone == "AM") {
                                        if (date("H",$end_t) == 12)
                                                $end_t = strtotime("-12 hours",$end_t);
                                }

                                $termin = array('start'=>$start_t,
                                                'end'=>$end_t,
                                                'title'=>$subject,
                                                'content'=>$description,
                                                'location'=>$location);
                                array_push($ret, $termin);
                        }

                }

                return $ret;
        }

	function outlook_csv_import($data) {
                $ret = array();
                $sig = array
                (
                    0 => "Betreff",
                    1 => "Beginnt am",
                    2 => "Beginnt um",
                    3 => "Endet am",
                    4 => "Endet um",
                    5 => "Ganztgiges Ereignis",
                    6 => "Erinnerung Ein/Aus",
                    7 => "Erinnerung am",
                    8 => "Erinnerung um",
                    9 => "Besprechungsplanung",
                    10 => "Erforderliche Teilnehmer",
                    11 => "Optionale Teilnehmer",
                    12 => "Besprechungsressourcen",
                    13 => "Abrechnungsinformationen",
                    14 => "Beschreibung",
                    15 => "Kategorien",
                    16 => "Ort",
                    17 => "Prioritt",
                    18 => "Privat",
                    19 => "Reisekilometer",
                    20 => "Vertraulichkeit",
                    21 => "Zeitspanne zeigen als\""
                );

                /*
            [0] => Array
                (
                    [0] => Betreff
                    [1] => Beginnt am
                    [2] => Beginnt um
                    [3] => Endet am
                    [4] => Endet um
                    [5] => Ganztgiges Ereignis
                    [6] => Erinnerung Ein/Aus
                    [7] => Erinnerung am
                    [8] => Erinnerung um
                    [9] => Besprechungsplanung
                    [10] => Erforderliche Teilnehmer
                    [11] => Optionale Teilnehmer
                    [12] => Besprechungsressourcen
                    [13] => Abrechnungsinformationen
                    [14] => Beschreibung
                    [15] => Kategorien
                    [16] => Ort
                    [17] => Prioritt
                    [18] => Privat
                    [19] => Reisekilometer
                    [20] => Vertraulichkeit
                    [21] => Zeitspanne zeigen als"
                )
                */
                foreach ($this->parse($data) as $k=>$line) {
                        if ($k == 0) {
                                if (count(array_diff_assoc($sig, $line))) {
                                        return "errorFalsches Dateiformat!";
                                }
                                continue;
                        }
			$start_date  = str_replace("\"","",trim($line[1]));
                        $start_time  = str_replace("\"","",trim($line[2]));
                        $end_date    = str_replace("\"","",trim($line[3]));
                        $end_time    = str_replace("\"","",trim($line[4]));
                        $subject     = str_replace("\"","",trim($line[0]));
                        $description = str_replace("\"","",trim($line[14]));
                        $location    = str_replace("\"","",trim($line[16]));

                        if ($subject!='' && $start_date!='' && $start_time!='' && $end_date!='' && $end_time!='') {
                                $start = $start_date.' '.$start_time;
                                $start_t = strtotime($start);

                                $end = $end_date.' '.$end_time;
                                $end_t = strtotime($end);

                                $termin = array('start'=>$start_t,
                                                'end'=>$end_t,
                                                'title'=>$subject,
                                                'content'=>$description,
                                                'location'=>$location);
                                array_push($ret, $termin);
                        }

                }
                return $ret;
        }


	function parse_import_datei($datei, $datei_size, $datei_name, $format) {
                $tmp_file_id = md5(uniqid(rand()));
                $tmp_file_name = $GLOBALS['TMP_PATH']."/".$tmp_file_id;

                $msg = "";

                if (!($datei)){ //keine Datei ausgewhlt!
                        $msg = "error" . _("Sie haben keine Datei zum Hochladen ausgewhlt!")."";
                        return $msg;
                }
                if ($datei_size==0) {
                        $msg = "error"._("Fehler beim hochladen der Datei! Dateigr&ouml;sse 0 Byte!")."";
                        return $msg;
                }

                if(!@copy($datei, $tmp_file_name)){
                        @unlink($tmp_file_name);
                        $msg = "error" . _("Es ist ein Fehler beim Kopieren der Datei $datei aufgetreten!");
                        return $msg;
                }

                // ab hier sollte es keine Probleme mehr geben, wir koennen mit dem Parsen beginnen...

                $data = "";
                $fp=fopen($tmp_file_name,"r");
                while(!feof($fp)) {
                        $data .= fread($fp,4096);
                }
                fclose($fp);

                if ($format == "fc_csv")
                        return $this->fc_csv_import($data);
                else if ($format == "outlook_csv")
                        return $this->outlook_csv_import($data);

                return "errorUnbekanntes Dateiformat!";
        }

	/**
     * Create a 2D array from a CSV string
     *
     * @param mixed $data 2D array
     * @param string $delimiter Field delimiter
     * @param string $enclosure Field enclosure
     * @param string $newline Line seperator
     * @return
     */
    function parse($data, $delimiter = ',', $enclosure = '"', $newline = "\n"){
        $pos = $last_pos = -1;
        $end = strlen($data);
        $row = 0;
        $quote_open = false;
        $trim_quote = false;

        $return = array();

        // Create a continuous loop
        for ($i = -1;; ++$i){
            ++$pos;
            // Get the positions
            $comma_pos = strpos($data, $delimiter, $pos);
            $quote_pos = strpos($data, $enclosure, $pos);
            $newline_pos = strpos($data, $newline, $pos);

            // Which one comes first?
            $pos = min(($comma_pos === false) ? $end : $comma_pos, ($quote_pos === false) ? $end : $quote_pos, ($newline_pos === false) ? $end : $newline_pos);

            // Cache it
            $char = (isset($data[$pos])) ? $data[$pos] : null;
            $done = ($pos == $end);

            // It it a special character?
            if ($done || $char == $delimiter || $char == $newline){

                // Ignore it as we're still in a quote
                if ($quote_open && !$done){
                    continue;
                }

                $length = $pos - ++$last_pos;

                // Is the last thing a quote?
                if ($trim_quote){
                    // Well then get rid of it
                    --$length;
                }

                // Get all the contents of this column
                $return[$row][] = ($length > 0) ? str_replace($enclosure . $enclosure, $enclosure, substr($data, $last_pos, $length)) : '';

                // And we're done
                if ($done){
                    break;
                }

                // Save the last position
                $last_pos = $pos;

                // Next row?
                if ($char == $newline){
                    ++$row;
                }

                $trim_quote = false;
		}
            // Our quote?
            else if ($char == $enclosure){

                // Toggle it
                if ($quote_open == false){
                    // It's an opening quote
                    $quote_open = true;
                    $trim_quote = false;

                    // Trim this opening quote?
                    if ($last_pos + 1 == $pos){
                        ++$last_pos;
                    }

                }
                else {
                    // It's a closing quote
                    $quote_open = false;

                    // Trim the last quote?
                    $trim_quote = true;
                }

            }

        }

        return $return;
    }


}

?>
