<?
/**
* Plugin zum Verwalten eines Gruppenkalenders
*
* @author               Jan Kulmann <jankul@zmml.uni-bremen.de>
*
*/

// +---------------------------------------------------------------------------+
// This file is NOT part of Stud.IP
// Copyright (C) 2008 Jan Kulmann <jankul@zmml.uni-bremen.de>
// ATTENTION: Please send ALL bug reports and security leaks directly to the author.
//            Thx!
// +---------------------------------------------------------------------------+
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or any later version.
// +---------------------------------------------------------------------------+
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// +---------------------------------------------------------------------------+


page_open(array('sess' => 'Seminar_Session', 'auth' => 'Seminar_Default_Auth', 'perm' => 'Seminar_Perm', 'user' => 'Seminar_User'));

$GLOBALS['perm']->check('autor');

require_once("classes/GkConfig.class.php");
require_once("classes/DBM.class.php");
require_once("classes/DateObject.class.php");
require_once("classes/DownloadManager.class.php");
require_once("lib/functions.php");
require_once('vendor/flexi/template_factory.php');

function get_email($user_id="") {
	$db=new DB_Seminar;
	$db->query ("SELECT Email FROM auth_user_md5 WHERE user_id = '$user_id'");
	while ($db->next_record())
		$author=$db->f("Email");
	if ($author=="") $author= _("unbekannt");
	
	 return $author;
}



$template_path = dirname(__FILE__) . '/templates/flexi/ical';
$factory = new Flexi_TemplateFactory($template_path);

if (!array_key_exists('cmd', $_REQUEST)) die;
$range_id = escapeshellcmd(basename(trim($_REQUEST['rid'])));
$termin_id = escapeshellcmd(basename(trim($_REQUEST['tid'])));
$config = new GkConfig($GLOBALS['auth']->auth['uid'], $range_id);
$dbm = new DBM(&$config);

switch($_REQUEST['cmd']) {
	case 'getSingleDate':
		if (!($termin_id && $range_id)) die;
		$tt = $dbm->getSingleDate($termin_id, $range_id);
		$t = $tt[0];
		if (($GLOBALS['perm']->have_studip_perm('autor', $range_id) && $range_id == $t->getRangeId()) || $GLOBALS['auth']->auth['uid'] == $t->getUserId()) {
			$t_content = "";
			if ($t->getSrc() == "tv_cal") {
	                        $buchungen = DBM::getTerminBuchungen($t->getTerminId());
                                $template = $factory->open('details_terminbuchung');
                                $template->set_attribute('anz_buchungen', $buchungen['anz_buchungen']);
                                $template->set_attribute('bookings', $buchungen['bookings']);
                                $t_content = $template->render();
                        }

			$template = $factory->open('single_date');
			$template->set_attribute('title', utf8_encode(kill_format($t->getTitle())));
			$template->set_attribute('id', $t->getTerminId());
			$template->set_attribute('author', utf8_encode(get_fullname($t->getUserId())));
			$template->set_attribute('author_mail', get_email($t->getUserId()));
			$template->set_attribute('location', utf8_encode(kill_format($t->getOrt())));
			$template->set_attribute('content', utf8_encode(kill_format($t->getContent()).$t_content));
			$template->set_attribute('startzeit', date("Ymd",$t->getVon())."T".date("Hi",$t->getVon())."00");
			$template->set_attribute('endzeit', date("Ymd",$t->getBis())."T".date("Hi",$t->getBis())."00");
			$template->set_attribute('mkdate', date("Ymd",$t->getMkdate())."T".date("Hi",$t->getMkdate())."00");
			if ($t->getChdate() != null)
				$template->set_attribute('chdate', "LAST-MODIFIED:".date("Ymd",$t->getChdate())."T".date("Hi",$t->getChdate())."00");

			$body = $template->render();

			$template = $factory->open('ical_container');
			$template->set_attribute('events', $body);

			$d = new DownloadManager($template->render(), "termin.ics", "text/calendar");
			$d->download();
		}
		break;
	case 'getDateRange':
		$von = escapeshellcmd(basename(trim($_REQUEST['start'])));
		$bis = escapeshellcmd(basename(trim($_REQUEST['end'])));
		if (!($range_id && $von && $bis)) die;
		if ($GLOBALS['perm']->have_studip_perm('autor', $range_id)) {
			$body = "";
			$dates = $dbm->getDatesInRange($von, $bis, $range_id);
			if (count($dates)>0) {
				foreach ($dates as $t) {
					$t_content = "";
					if ($t->getSrc() == "tv_cal") {
						$buchungen = DBM::getTerminBuchungen($t->getTerminId());
						$template = $factory->open('details_terminbuchung');
						$template->set_attribute('anz_buchungen', $buchungen['anz_buchungen']);
						$template->set_attribute('bookings', $buchungen['bookings']);
						$t_content = $template->render();
					}
					$template = $factory->open('single_date');
					$template->set_attribute('title', utf8_encode(kill_format($t->getTitle())));
					$template->set_attribute('id', $t->getTerminId());
					$template->set_attribute('author', utf8_encode(get_fullname($t->getUserId())));
					$template->set_attribute('author_mail', get_email($t->getUserId()));
					$template->set_attribute('location', utf8_encode(kill_format($t->getOrt())));
					$template->set_attribute('content', utf8_encode(kill_format($t->getContent()).$t_content));
					$template->set_attribute('startzeit', date("Ymd",$t->getVon())."T".date("Hi",$t->getVon())."00");
					$template->set_attribute('endzeit', date("Ymd",$t->getBis())."T".date("Hi",$t->getBis())."00");
					$template->set_attribute('mkdate', date("Ymd",$t->getMkdate())."T".date("Hi",$t->getMkdate())."00");
					if ($t->getChdate() != null)
						$template->set_attribute('chdate', "LAST-MODIFIED:".date("Ymd",$t->getChdate())."T".date("Hi",$t->getChdate())."00");
					
					$body .= $template->render();
				}
				$template = $factory->open('ical_container');
				$template->set_attribute('events', $body);

				$d = new DownloadManager($template->render(), "termin.ics", "text/calendar");
				$d->download();
			}
		}
		break;
	case 'getSerie':
		if (!($termin_id && $range_id)) die;
		$t = new DateObject();
		$t->load($termin_id);
		if ($GLOBALS['perm']->have_studip_perm('autor', $range_id) && $range_id == $t->getRangeId()) {
			$body = "";
			$serie = DBM::getSerie($t->getSerieId(), $range_id);
			foreach ($serie as $s) {
				$template = $factory->open('serie_date');
				$template->set_attribute('title', utf8_encode(kill_format($s->getTitle())));
				$template->set_attribute('serie_id', $s->getSerieId());
				$template->set_attribute('author', utf8_encode(get_fullname($s->getUserId())));
				$template->set_attribute('author_mail', get_email($s->getUserId()));
				$template->set_attribute('location', utf8_encode(kill_format($s->getOrt())));
				$template->set_attribute('content', utf8_encode(kill_format($s->getContent())));
				$template->set_attribute('startzeit', date("Ymd",$s->getVon())."T".date("Hi",$s->getVon())."00");
				$template->set_attribute('endzeit', date("Ymd",$s->getBis())."T".date("Hi",$s->getBis())."00");
				$template->set_attribute('mkdate', date("Ymd",$s->getMkdate())."T".date("Hi",$s->getMkdate())."00");
				if ($s->getChdate() != null)
					$template->set_attribute('chdate', "LAST-MODIFIED:".date("Ymd",$s->getChdate())."T".date("Hi",$s->getChdate())."00");

				$body .= $template->render();
			}

			$template = $factory->open('ical_container');
			$template->set_attribute('events', $body);

			$d = new DownloadManager($template->render(), "termin.ics", "text/calendar");
			$d->download();
		}
		break;
default: ;
}
?>
